function fetchWorkspaces() {
    $("#login_form").hide();
    $.ajax({
        url: window.workspaceDefineUrl || '/workspace/index.json',
        method: 'GET',
        success: function (response) {
            var data = response;
            var workspaces = data.workspaces;
            var domWorkspaceList = [];
            for (var i = 0; i < workspaces.length; i++) {
                var workspace = workspaces[i];
                var workspaceName = workspace.name;
                var workspaceInfo = JSON.stringify(workspace);
                domWorkspaceList.push($("<option></option>").data("workspace", workspaceInfo).text(workspaceName));
            }
            $("#workspace_select").append(domWorkspaceList);
        },
        error: function (xhr, status, error) {
            alert("获取工作区失败！");
        }
    });
}
function useWorkspace() {
    var workspaceInfo = $("#workspace_select option:selected").data("workspace");
    var workspace = JSON.parse(workspaceInfo);
    window.workspace = workspace;
    if (workspace.domain) {
        $("#inputDomain").val(workspace.domain);
    }
    if (workspace.domainImmutable) {
        $("#inputDomain").attr("readonly", true).hide();
    }
    if (workspace.extraInfos) {
        $("#extraInfos")[0].innerHTML = workspace.extraInfos;
    }
    $("#workspace_select_form").hide();
    $("#login_form").show();
    if (event) {
        event.preventDefault();
        return false;
    }
}
function connect(user, password, domain, performanceFlags, event) {
    jsExportedCredentials.user = user;
    jsExportedCredentials.password = password;
    jsExportedCredentials.domain = domain;
    jsExportedCredentials.performanceFlags = performanceFlags.toString();
    jsExportedCredentials.wsurl = (window.workspace.websocketUrl.startsWith("wss://") || window.workspace.websocketUrl.startsWith("ws://")) ? 
        window.workspace.websocketUrl : (window.location.protocol == "https:" ? "wss://" : "ws://") + window.location.host + window.workspace.websocketUrl;
    $.ajax({
        url: window.workspace.filegateway.url,
        method: "POST",
        data: {
            username: user,
            password: password,
            domain: domain
        },
        success: function (response) {
            var data = response;
            var sessionId = data.sessionId;
            initFile(sessionId, window.workspace.filegateway);
        },
        error: function (xhr, status, error) {
            alert("文件服务登录失败！");
        }
    });
    window.wasm().then(() => {
        $('#login_container').hide();
        $('#rdp_container').show();
    }).catch((err) => {
        alert(err);
    });
    if (event) {
        event.preventDefault();
        return false;
    }
}